<?php

	class wialon_hosting {
		public $sid = "";
		public $id_user_session = "";
		public $id_resource_session = "";
		public $id_tp_session = "";
	   
		public $dns = "";
		public $login_name = "";
		public $login_pass = "";
		private $log = "";
		
		public $debug_mode = "0";
		
		private $array_coord = "";
		private $ind_coord = 0;
		
		function __construct() {
			
			$this->log = new logs("wialon_hosting");
			$this->dns = "hst-api.wialon.com";
			$this->login_name = "wialon";
			$this->login_pass = "wialon";
			
			$this->login();	
		}
		
		// login
		function login() 
		{	
			if ($this->debug_mode == "1")
				$this->log->trace("Attempt login to wialon hosting" . $this->dns . ", login=" . $this->login_name);
				
			$result_login = $this->wialon_request("core/login","{\"user\":\"" . $this->login_name . "\", \"password\":\"" . $this->login_pass . "\"}");
			if ($result_login == "error") {
				$this->log->trace("Error login to wialon hosting " . $this->dns . ", login=" . $this->login_name);
				return;
			}
			$this->sid = $result_login -> {'eid'};
			$this->id_user_session = $result_login ->{'user'} -> {'id'};	
			$this->id_resource_session = $result_login->{'user'}->{'bact'};	
			
			if ($this->debug_mode == "1")
				$this->log->trace("Login to wialon hosting (sid: " . $this->sid . ")");
				
			if ($this->id_resource_session != "") {
			
				$lang = "ru";
				if (isset($result_login->{'user'}->{'prp'}->{'language'}))
					$lang = $result_login->{'user'}->{'prp'}->{'language'};
				// localisation
				$this->wialon_request("render/set_locale",'{"tzOffset":' . $result_login->{'user'}->{'prp'}->{'tz'} . ',"language":"' . $lang . '"}');
			
				$account = $this->wialon_request("core/get_account_data",'{"type":1}');
				if ($account != "error" &&  isset($account->{'plan'}))	{
					$letters = array('.', '-', ' ');
					$replace_letter   = array('_', '_','_');
					$this->id_tp_session = str_replace($letters, $replace_letter, $account->{'plan'});
					
					if ($this->debug_mode == "1")
						$this->log->trace("Good get account info (TP: " . $this->id_tp_session . ")");
				}
				
				if (isset($result_login->{'user'}->{'prp'}->{'trackingm_logo'}))
					$this->id_tp_session = $result_login->{'user'}->{'prp'}->{'trackingm_logo'};
				
			}
						
		}
		// logout
		function logout() 
		{
			if ($this->sid == "")
				return "error";
			
			if ($this->debug_mode == "1")			
				$this->log->trace("Logout wialon hosting (sid: " . $this->sid . ")");
			$this->wialon_request("core/logout","{}");
			$this->sid = "";
			$this->id_user_session = "";
		}
		// request to wialon with socket
		function wialon_request($svc,$params,$now_decode=0) 
		{
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			if ($this->sid != "")
				$data = "svc=" . $svc . "&sid=" . $this->sid . "&params=" . $params . "\r\n";
			else 
				$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("request: " . $data);
			}
			
			$out = "POST /wialon/ajax.html HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->log->trace("answer: " . $html);
			}
			if ($now_decode == 1) 
				$json = $html;
			else {
				$json = json_decode($html);
				if (isset($json->{'error'}) && $json->{'error'} != "") {
					$this->log->trace("Errro request to Wialon (sid: " . $this->sid . ") : " . $html);
					return "error";
				}
			}
			return $json;
		}
				
		// get units array
		function get_items($type,$flags)
		{
			$params = '{"spec":{"itemsType":"' . $type . '","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":' . $flags . ',"from":0,"to":"0xffffffff"}';
			$items = $this->wialon_request("core/search_items",$params);
			
			if (isset($items->{'items'}))
			      return $items -> {'items'};
			else
			      return ""; 
		}
		
		// check sid
		function check_sid()
		{
			$params = '{"spec":{"itemsType":"avl_unit","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":0x1,"from":0,"to":"0xffffffff"}';
			if ($this->wialon_request("core/search_items",$params) == "error")
				return "false";
			else
				return "true";
		}
		
		// serach items from id
		function search_items_from_id($items,$id)
		{
			if(is_array($items))
			foreach($items as $item) {
				$name_item = $item->{'nm'};
				$id_item = $item->{'uid'};
				
				if ($id_item == $id) 
					return $item;
				
			}
			return "";
		}
		
		// serach report from name
		function search_report_from_name($name)
		{
			$resources = $this->get_items("avl_resource",0x2001);
			if(is_array($resources))
			foreach($resources as $resource) {
				$reports = $resource->{'d'}->{'rep'};
				if ($reports == "")
					continue;
				if($reports != "")
				foreach($reports as $report) {
					if ($this->debug_mode == "1") 
						$this->sk_trace("reoprt name " . $report->{'n'});
										
					if ($report->{'n'} == $name)
						return Array("res_id" => $resource->{'i'},"templ_id" => $report->{'id'});					
				}
			}
			
			return "";
		}
		
		function get_reports() {
			$res_array = "";
		
			$resources = $this->get_items("avl_resource",0x2001);
			if ($resources == "") {
				$this->log->trace("answer: null resource");
			}
			if(is_array($resources))
			foreach($resources as $resource) {
				$reports = $resource->{'rep'};
				if ($reports == "")
					continue;
				if($reports != "")
				foreach($reports as $report) {
					
					if ($report->{'ct'} != "avl_unit") {
						continue;
					}
					
					if ($res_array != "")
						$res_array = $res_array . ",";
													
					$res_array = $res_array . '{"name":"'. $report->{'n'} . '","id":"'. $report->{'id'} . '","resource_id":"'. $resource->{'id'}.'"}';		
					
				}
			}
		
			return $res_array;
		}
		
		function get_geoitems() {
			$res_array = "";
		
			$resources = $this->get_items("avl_resource",0x1801);
			if ($resources == "") {
				$this->log->trace("answer: null resource");
			}	
			if(is_array($resources))
			foreach($resources as $resource) {
				$pois = "";
				$zones = "";
				if (isset($resource->{'poi'}))
					$pois = $resource->{'poi'};
				if (isset($resource->{'zl'}))
					$zones = $resource->{'zl'};
					
				if($pois != "")
				foreach($pois as $poi) {
					if ($res_array != "")
						$res_array = $res_array . ",";
													
					$res_array = $res_array . '{"type":"poi","name":"'. $poi->{'n'} . '","lat":'. $poi->{'y'} . ',"lon":'. $poi->{'x'} .'}';
				}
				if($zones != "")
				foreach($zones as $zone) {
					if ( $zone->{'t'} != 2)
						continue;
				
					$points = "";
					$zone_info = $this->wialon_request("resource/get_zone_data",'{"itemId":' . $resource->{'id'} . ',"col":[' . $zone->{'id'} . ']}');
					if ($zone_info != "" && $zone_info != "error" && isset($zone_info[0]->{'p'}))
						foreach($zone_info[0]->{'p'} as $zone_point) {
							if ($points != "")
								$points = $points . ",";
															
							$points = $points . '{"lat":' . $zone_point->{'y'} . ',"lon":'. $zone_point->{'x'} . '}';		
						}
						
				
					if ($res_array != "")
						$res_array = $res_array . ",";
				
					$res_array = $res_array . '{"type":"zone","name":"'. $zone->{'n'} . '","points":[' . $points . ']}';		
				}
			}
			return $res_array;
		}
		
		function get_groups() {
			$res_array = "";
			$units = $this->get_items("avl_unit",0x401);
			$groups = $this->get_items("avl_unit_group",0x1);

			$this->array_coord = "";
			$this->ind_coord = 0;
			
			$count_units = 0;
			$limit_count_units = 300;
			$select_id_unit = array();
			
			if(is_array($groups))
			foreach($groups as $group) {

				$name_group = $group->{'nm'};
				$id_group = $group->{'id'};
				$unit_ids = $group->{'u'};

				$info_units = "";
				
				if(is_array($unit_ids))
				foreach($unit_ids as $unit_id) {
					if(is_array($units))
					foreach($units as $unit) {
						$id_unit = $unit->{'id'};
						if ($id_unit == $unit_id) {
							$name_unit = $unit->{'nm'};
							$pos_unit = $unit->{'pos'};
							
							if ($info_units != "")
								$info_units = $info_units . ",";

							$info_units = $info_units . $this->get_json_msg($name_unit,$id_unit,$pos_unit);							
							$select_id_unit[] = $id_unit;
							break;
						}
					}
					
					$count_units = $count_units + 1;
					if ($count_units > $limit_count_units)
						break;
				}
				
				if ($res_array != "")
					$res_array = $res_array . ",";

					
				$res_array = $res_array . "{\"name\":\"$name_group\",\"id\":\"$id_group\",\"units\":[$info_units]}";

			}
			
			$count_units = 0;
			$info_units = "";
			if(is_array($units))
			foreach($units as $unit) {
				$id_unit = $unit->{'id'};
				
				$flag = 0;
				foreach($select_id_unit as $select_id)
					if ($select_id == $id_unit) {
						$flag = 1;
						break;
					}
						
				if ($flag == 1)
					continue;
			
					
				$name_unit = $unit->{'nm'};
				$pos_unit = $unit->{'pos'};
				
				if ($info_units != "")
					$info_units = $info_units . ",";
	
				$info_units = $info_units . $this->get_json_msg($name_unit,$id_unit,$pos_unit);
				
				$count_units = $count_units+ 1;
				if ($count_units > $limit_count_units)
					break;
						
			}
			
			if ($res_array != "")
					$res_array = $res_array . ",";

					
			$res_array = $res_array . "{\"name\":\"Объекты вне группы\",\"id\":\"0\",\"units\":[$info_units]}";

			//	http://{host}/gis_geocode?coords=[{"lon":<double>,"lat":<double>}]&city_radius=<uint>&
			// 	dist_from_unit=<uint>&txt_dist=<text>&flags=<uint>&tags=<text>&uid=<long>
						
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			$data = "coords=[" . $this->array_coord . "]&uid=" . $this->sid . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("address request: " . $data);
			}
			
			
			$out = "POST /gis_geocode HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->log->trace("answer: " . $html);
			}
			
			$json = json_decode($html);
			if (isset($json)) {
				$ind = 0;
				if(is_array($json))
				foreach($json as $loc) {
					$loc = str_replace('"', '\'', $loc);
					$loc = str_replace("\r", "", $loc);
					$loc = str_replace("\n", "", $loc);
					$loc = str_replace("\\", "_", $loc);
					$loc = str_replace("/", "_", $loc);
					
					$ind++;					
					$res_array = str_replace("loc_" . $ind . "_", $loc, $res_array);
				}
			}
			
			return $res_array;	
		}
		
		// get json pos msg
		function get_json_msg($name,$id,$pos) {
			$time_unit = 0;
			$lat_unit = 0;
			$lon_unit = 0;
			$speed_unit = 0;
			$sats_unit = 0;
			$address = "";
			if ($pos != "") {
			
				if (isset($pos->{'t'}))
					$time_unit = $pos->{'t'};
				if (isset($pos->{'y'}))
					$lat_unit = $pos->{'y'};
				if (isset($pos->{'x'}))
					$lon_unit = $pos->{'x'};
				if (isset($pos->{'s'}))
					$speed_unit = $pos->{'s'};
				if (isset($pos->{'sc'}))
					$sats_unit = $pos->{'sc'};
				
				$address = $this->get_address($lat_unit,$lon_unit);
			}
							
			return '{"name":"'. $name.'","id":"'.$id.'","time":'.$time_unit.',"lat":'.$lat_unit.',"lon":'.$lon_unit.',"speed":'.$speed_unit.',"sats":'.$sats_unit.',"address":"'.$address.'"}';
		}
		
		// get address
		function get_address($lat,$lon) {
		
			if ($lat == 0 || $lon == 0)
				return "";
				
			if ($this->array_coord != "")
				$this->array_coord = $this->array_coord . ",";
			
			$this->array_coord = $this->array_coord . '{"lon":' . $lon . ',"lat":' . $lat . '}';
			$this->ind_coord++;
			
			return "loc_" . $this->ind_coord . "_";	
		
			//	http://{host}/gis_geocode?coords=[{"lon":<double>,"lat":<double>}]&city_radius=<uint>&
			// 	dist_from_unit=<uint>&txt_dist=<text>&flags=<uint>&tags=<text>&uid=<long>
						
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			$data = "coords=[{\"lon\":" . $lon . ",\"lat\":" . $lat . "}]&uid=" . $this->sid . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("address request: " . $data);
			}
			
			
			$out = "POST /gis_geocode HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->log->trace("answer: " . $html);
			}
			
			$json = json_decode($html);
			
			return $json[0];
			
			
			return "";
		}
		
		function get_msgs($unit_id,$from,$to) {
			
			$result = "";
			
			$msgs = $this->wialon_request("messages/load_interval",'{"itemId":"' . $unit_id . '","timeFrom":' . $from . ',"timeTo":' . $to . ',"flags":0x0,"flagsMask":0xFF00,"loadCount":0xFFFFFFFF}');
			if ($msgs != "error") 
				$msgs = $msgs->{'messages'};
			else
				return "";
			if(is_array($msgs))
			foreach($msgs as $msg) {
				$msg_time = $msg->{'t'};
				$msg_lon = $msg->{'pos'}->{'x'};
				$msg_lat = $msg->{'pos'}->{'y'};
				$msg_speed = $msg->{'pos'}->{'s'};
				$msg_course = $msg->{'pos'}->{'c'};
				$msg_alt = $msg->{'pos'}->{'z'};
				$msg_sats = $msg->{'pos'}->{'sc'};
									
				if (($msg_speed == "" && $msg_course == "")) { continue; }
				
				if ($result != "")
					$result = $result . ",";
					
				$result = $result . '{"time":' . $msg_time . ',"lat":'.$msg_lat.',"lon":'.$msg_lon.',"speed":'.$msg_speed.',"course":'.$msg_course.',"alt":'.$msg_alt.',"sats":'.$msg_sats.'}';
				
			}
			
			return $result;
		}
		
		function get_unit_info($unit_id) {
		
			//get_list_drivers
			$driver_data = '{"name":"","phone":""}';
			
			$resources = $this->get_items("avl_resource",0x100);
			if(is_array($resources))
			foreach($resources as $resource) {
				if (isset($resource->{'drvrs'}))
					$drivers = $resource->{'drvrs'};
				else
					continue;
					
				if(is_array($drivers))
				foreach($drivers as $driver) {
					if (isset($driver->{'bu'}) && $driver->{'bu'} == $unit_id) {
						$driver_data = '{"name":"' . $driver->{'n'} . '","phone":"' . $driver->{'p'} . '"}';
						break;
					}
				}
			}			
			
			$this->log->trace("drv: " . $driver_data);
			
			$result = "";
			$unit = $this->wialon_request("core/search_item",'{"id":"' . $unit_id . '","flags":0x101701}');
			if ($unit == "error") 
				return "";
			
			if (isset($unit->{'item'}))
				$unit = $unit->{'item'};
			else 
				return "";			
			
			$params = "";
			
			if (isset($unit->{'prms'})) {
				foreach($unit->{'prms'} as $name_sens => $sens) {				
								
					if(gettype($sens->{'v'}) == "object")
						continue;
												
					if ($params != "")
						$params = $params . ", ";
					
					$sens_value = $sens->{'v'};
					
					$sens_value = str_replace('"', '\'', $sens_value);
					$sens_value = str_replace("\r", "", $sens_value);
					$sens_value = str_replace("\n", "", $sens_value);
					$sens_value = str_replace("\\", "_", $sens_value);
					$sens_value = str_replace("/", "_", $sens_value);
					
					$params = $params . $name_sens . ": " . $sens_value;
				}
			}
			
			$sensors_id_name = array();
			if (isset($unit->{'sens'})) {
				foreach($unit->{'sens'} as $sens)
					$sensors_id_name[$sens->{'id'}] = $sens->{'n'};
			}
			
			$sensors = "";
			$sens_arr = $this->wialon_request("unit/calc_last_message",'{"unitId":' . $unit_id . '}');
			if ($sens_arr != "error") {
				foreach($sens_arr as $name_sens => $sens) {
					if ($sensors != "")
						$sensors = $sensors . ", ";
						
					$sensors = $sensors . $sensors_id_name[$name_sens] . ": " . $sens;					
				}
			}
			
			$cmds = "";
			if (isset($unit->{'cmds'})) {
				foreach($unit->{'cmds'} as $cmd) {				
								
					if ($cmds != "")
						$cmds = $cmds . ", ";
					
					$cmds = $cmds . '"' . $cmd->{'n'} . '"';
				}
			}
			
			$phone = "";
			if (isset($unit->{'ph'}))
				$phone = $unit->{'ph'};
			
			$result = $result . 	'"name":"' . $unit->{'nm'} . '",' . 
						'"phone":"' . $phone . '",' . 
						'"cmd":[' . $cmds . '],' . 
						'"pos":' . json_encode($unit->{'pos'}) . ',' . 
						'"params":"' . $params . '"' . ',' . 
						'"sensors":"' . $sensors . '"' . ',' . 
						'"driver":' . $driver_data;
			return $result;
		}
		
		function exec_report($unit_id,$from,$to,$report_id,$resource_id,$format,$lang,$tzoffset) {
			
			if ($format == "html" || $format == "HTML" ) {
				$format = 1;
			} else if ($format == "pdf" || $format == "PDF" ) {
				$format = 2;
			} else if ($format == "xls" || $format == "XLS" ) {
				$format = 4;
			} else {
				$format = 1;
			}
			
			$result = "";
			//clear old report
			$this->wialon_request("report/cleanup_result","{}");
			
			$this->wialon_request("report/exec_report",'{"reportResourceId":'.$resource_id.',"reportTemplateId":'.$report_id.',"reportObjectId":'.$unit_id.',"reportObjectSecId":0,"interval":{"from":'.$from.',"to":'.$to.',"flags":0},"reportTemplate":0}');
			
			$data = $this->wialon_request("report/export_result",'{"format":'.$format.',"pageOrientation":"landscap","pageSize":"","pageWidth":"1","coding":"utf8","delimiter":"semicolon","headings":"1","compress":"0","attachMap":"0","hideMapBasis":"1","outputFileName":"'. time() .'"}',1);
			
			return $data;
		}
		
		function exec_cmd($unit_id,$cmd,$data) {
			
			$unit = $this->wialon_request("core/search_item",'{"id":"' . $unit_id . '","flags":0x200}');
			if ($unit == "error") 
				return "error";
			
			if (isset($unit->{'item'}))
				$unit = $unit->{'item'};
			else 
				return "error";
			
			if (isset($unit->{'cmds'})) {
				foreach($unit->{'cmds'} as $cmd_unit) {						
					$name_cmd = $cmd_unit->{'n'};
					if ($cmd == $name_cmd) {
						$type_link = $cmd_unit->{'t'};
						
						$exec = $this->wialon_request("unit/exec_cmd",'{"itemId":' . $unit_id . ',"commandName":"' . $name_cmd . '","linkType":"' . $type_link . '","param":"' . $data . '","timeout":20,"flags":0}');
						if ($exec != "error")
							return "ok";
						
						break;
					}
				}
			}
			return "error";
		}
	} 

?>
