<?php

	class wialon_pro {
		public $sid = "";
		public $id_user_session = "";
		public $id_tp_session = "";
				
		private $dns = "";
		public $login_name = "";
		private $login_pass = "";
		private $log = "";
		
		private $debug_mode = "0";
		
		private $array_coord = "";
		private $ind_coord = 0;
	
		function __construct($type) {
			
			$this->log = new logs("wialon_pro");
			
			if ($type == 1)
				$this->dns = "sdk.wialon.pro";
			else
				$this->dns = "sdk2.wialon.pro";
			
			$this->login_name = "wialon";
			$this->login_pass = "wialon";				
			
			$this->login();
				
		}
				
		// login
		function login() 
		{	
			if ($this->debug_mode == "1")
				$this->log->trace("Attempt login to wialon " . $this->dns . ", login=" . $this->login_name);
				
			$result_login = $this->wialon_request("core/login","{\"user\":\"" . $this->login_name . "\", \"password\":\"" . $this->login_pass . "\"}");
			if ($result_login == "error") {
				$this->log->trace("Error login to wialon " . $this->dns . ", login=" . $this->login_name);
				return;
			}
			if (isset($result_login -> {'ssid'}))
				$this->sid = $result_login -> {'ssid'};
			if (isset($result_login -> {'uid'}))
				$this->id_user_session = $result_login -> {'uid'};	
			if (isset($result_login -> {'user'}->{'pup'}->{'language'}))
				$this->lang = $result_login->{'user'}->{'pup'}->{'language'};
				
			if (isset($result_login->{'user'}->{'pup'}->{'tz'}))
				$this->tzoffset = $result_login->{'user'}->{'pup'}->{'tz'};
			
			$curr_user = $this->wialon_request("core/search_item",'{"itemId":' . $this->id_user_session . ',"flags":0x10}');
			if (isset($curr_user->{'flds'})) {
				$flds = $curr_user->{'flds'};
				$ind = 1;
				if(is_array($flds))
				foreach ($flds as $fld) {
					if (isset($fld->{'nm'})) {
						if ($fld->{'nm'} == "trackingm_logo") {
							$this->id_tp_session = $fld->{'vl'};
						}
					}
					$ind = $ind + 1;
				}	
			}
			
			if ($this->debug_mode == "1")
				$this->log->trace("Correct login to wialon (sid: " . $this->sid . ")");
				
		}
		// logout
		function logout() 
		{
			if ($this->sid == "")
				return "error";
			
			if ($this->debug_mode == "1")			
				$this->log->trace("Logout wialon (sid: " . $this->sid . ")");
			$this->wialon_request("core/logout","{}");
			$this->sid = "";
			$this->id_user_session = "";
			$this->pup_user_session = "";
		}
		// request to wialon with socket
		function wialon_request($svc,$params,$now_decode=0) 
		{
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this->log->trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			if ($this->sid != "")
				$data = "svc=" . $svc . "&ssid=" . $this->sid . "&params=" . $params . "\r\n";
			else 
				$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->log->trace("request: " . $data);
			}
			
			$out = "POST /ajax.html HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->log->trace("answer: " . $html);
			}
			
			if ($now_decode == 1) 
				$json = $html;
			else {
				$json = json_decode($html);
				if (isset($json->{'error'}) && $json->{'error'} != "") {			
					if ($json->{'error'} == "1001") {
						return "";
					}
					$this->log->trace("Errro request to Wialon (sid: " . $this->sid . ") : " . $html);
					return "error";
				}
			}
			
			return $json;
		}
			// get units array
		function get_items($type,$flags)
		{
			$params = '{"spec":{"itemsType":"' . $type . '","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":' . $flags . ',"from":0,"to":"0xffffffff"}';
			$items = $this->wialon_request("core/search_items",$params);
			
			if (isset($items->{'items'}))
			      return $items -> {'items'};
			else
			      return ""; 
		}
		
		// check sid
		function check_sid()
		{
			
			$params = '{"spec":{"itemsType":"avl_unit","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":0x1,"from":0,"to":"0xffffffff"}';
			if ($this->wialon_request("core/search_items",$params) == "error")
				return "false";
			else
				return "true";
		}
		
		function get_groups() {
			$res_array = "";
			$units = $this->get_items("avl_unit",0x401);
			$groups = $this->get_items("avl_unit_group",0x9);
			
			$this->array_coord = "";
			$this->ind_coord = 0;
			
			$count_units = 0;
			$limit_count_units = 300;
			$select_id_unit = array();
	
			if(is_array($groups))
			foreach($groups as $group) {

				$name_group = $group->{'nm'};
				$id_group = $group->{'id'};
				$unit_ids = $group->{'u'};

				$info_units = "";
				
				if(is_array($unit_ids))
				foreach($unit_ids as $unit_id) {
					if(is_array($units))
					foreach($units as $unit) {
						$id_unit = $unit->{'id'};
						if ($id_unit == $unit_id) {
							$name_unit = $unit->{'nm'};
							$pos_unit = $unit->{'pos'};
							
							
							if ($info_units != "")
								$info_units = $info_units . ",";
				
							$info_units = $info_units . $this->get_json_msg($name_unit,$id_unit,$pos_unit);
							$select_id_unit[] = $id_unit;
							break;
						}
					}
					
					$count_units = $count_units + 1;
					if ($count_units > $limit_count_units)
						break;
				}
				
				if ($res_array != "")
					$res_array = $res_array . ",";

					
				$res_array = $res_array . "{\"name\":\"$name_group\",\"id\":\"$id_group\",\"units\":[$info_units]}";

			}
			
			$count_units = 0;
			
			$info_units = "";
			if(is_array($units))
			foreach($units as $unit) {
				$id_unit = $unit->{'id'};
				
				$flag = 0;
				foreach($select_id_unit as $select_id)
					if ($select_id == $id_unit) {
						$flag = 1;
						break;
					}
						
				if ($flag == 1)
					continue;
			


				$name_unit = $unit->{'nm'};
				$pos_unit = $unit->{'pos'};
				
				if ($info_units != "")
					$info_units = $info_units . ",";
	
				$info_units = $info_units . $this->get_json_msg($name_unit,$id_unit,$pos_unit);
				
				$count_units = $count_units+ 1;
				if ($count_units > $limit_count_units)
					break;
			}
			
			if ($res_array != "")
					$res_array = $res_array . ",";

								
			$res_array = $res_array . "{\"name\":\"Объекты вне группы\",\"id\":\"0\",\"units\":[$info_units]}";
						
			// get_address
			$address = $this->wialon_request("gis/get_locations",'{"points":[' .  $this->array_coord . ']}');			
			if (isset($address->{'locations'})) {
				$ind = 0;
				foreach($address->{'locations'} as $loc) {
					$ind++;
					$loc = str_replace('"', '\'', $loc);
					$loc = str_replace("\r", "", $loc);
					$loc = str_replace("\n", "", $loc);
					$loc = str_replace("\\", "_", $loc);
					$loc = str_replace("/", "_", $loc);
										
					$res_array = str_replace("loc_" . $ind . "_", $loc, $res_array);
				}
			}
			
			return $res_array;	
		}
		
		// get json pos msg
		function get_json_msg($name,$id,$pos) {
			$time_unit = 0;
			$lat_unit = 0;
			$lon_unit = 0;
			$speed_unit = 0;
			$sats_unit = 0;
			$address = "";
			if ($pos != "") {
				if (isset($pos->{'t'}))
					$time_unit = $pos->{'t'};
				if (isset($pos->{'y'}))
					$lat_unit = $pos->{'y'};
				if (isset($pos->{'x'}))
					$lon_unit = $pos->{'x'};
				if (isset($pos->{'s'}))
					$speed_unit = $pos->{'s'};
				if (isset($pos->{'sc'}))
					$sats_unit = $pos->{'sc'};
					
				$address = $this->get_address($lat_unit,$lon_unit);
			}
										
			return '{"name":"'. $name.'","id":"'.$id.'","time":'.$time_unit.',"lat":'.$lat_unit.',"lon":'.$lon_unit.',"speed":'.$speed_unit.',"sats":'.$sats_unit.',"address":"'.$address.'"}';
		}
		
		
		function get_reports() {
			$res_array = "";
			$resources = $this->get_items("avl_resource",0x8001);
			if(is_array($resources))
			foreach($resources as $resource) {
				$reports = $resource->{'rep'};
				if ($reports == "")
					continue;
				if($reports != "")
				foreach($reports as $report) {
					
					if ($report->{'ct'} != "avl_unit") {
						continue;
					}
					
					if ($res_array != "")
						$res_array = $res_array . ",";
													
					$res_array = $res_array . '{"name":"'. $report->{'nm'} . '","id":"'. $report->{'id'} . '","resource_id":"'. $resource->{'id'}.'"}';		
					
				}
			}
		
			return $res_array;
		}
		
		function get_geoitems() {
			$res_array = "";
		
			$resources = $this->get_items("avl_resource",0x6001);
			if ($resources == "") {
				$this->log->trace("answer: null resource");
			}	
			if(is_array($resources))
			foreach($resources as $resource) {
				$pois = $resource->{'poi'};
				$zones = $resource->{'zl'};
				if($pois != "")
				foreach($pois as $poi) {
					if ($res_array != "")
						$res_array = $res_array . ",";
													
					$res_array = $res_array . '{"type":"poi","name":"'. $poi->{'nm'} . '","lat":'. $poi->{'y'} . ',"lon":'. $poi->{'x'} .'}';		
				}
				if($zones != "")
				foreach($zones as $zone) {
					if ( $zone->{'t'} != 2)
						continue;
				
					$points = "";
					$str_points = split(",",$zone->{'p'});
					for ($i = 0; $i < count($str_points); $i=$i+3) {
						if ($points != "")
							$points = $points . ",";
															
						$points = $points . '{"lat":' . $str_points[$i] . ',"lon":'. $str_points[$i+1] . '}';		
					}
					
					if ($res_array != "")
						$res_array = $res_array . ",";
				
					$res_array = $res_array . '{"type":"zone","name":"'. $zone->{'n'} . '","points":[' . $points . ']}';		
				}
			}
			return $res_array;
		}
		
		// get address
		function get_address($lat,$lon) {
						
			if ($lat == 0 || $lon == 0)
				return "";
			
			
			if ($this->array_coord != "")
				$this->array_coord = $this->array_coord . ",";
			
			$this->array_coord = $this->array_coord . '{"x":' . $lon . ',"y":' . $lat . '}';
			$this->ind_coord++;
			
			return "loc_" . $this->ind_coord . "_";
		}
		
		function get_msgs($unit_id,$from,$to) {
			
			$result = "";
			
			$msgs = $this->wialon_request("messages/load_interval",'{"itemId":' . $unit_id . ',"type":1,"ival1":' . $from . ',"ival2":' . $to . ',"flags":0,"flagsMask":0xFF00,"loadLocations":0,"loadCount":0xFFFFFFFF}');
			
			if ($msgs != "error") 
				$msgs = $msgs->{'messages'};
			
			if(is_array($msgs))
			foreach($msgs as $msg) {
				$msg_time = $msg->{'t'};
				$msg_lon = $msg->{'x'};
				$msg_lat = $msg->{'y'};
				$msg_speed = $msg->{'s'};
				$msg_course = $msg->{'c'};
				$msg_alt = $msg->{'z'};
				$msg_sats = $msg->{'sc'};
									
				if (($msg_speed == "" && $msg_course == "")) { continue; }
				
				if ($result != "")
					$result = $result . ",";
					
				$result = $result . '{"time":' . $msg_time . ',"lat":'.$msg_lat.',"lon":'.$msg_lon.',"speed":'.$msg_speed.',"course":'.$msg_course.',"alt":'.$msg_alt.',"sats":'.$msg_sats.'}';
				
			}
			
			return $result;
		}
		
		function exec_report($unit_id,$from,$to,$report_id,$resource_id,$format,$lang,$tzoffset) {
						
			if ($format == "html" || $format == "HTML" ) {
				$format = 1;
			} else if ($format == "pdf" || $format == "PDF" ) {
				$format = 2;
			} else if ($format == "xls" || $format == "XLS" ) {
				$format = 4;
			} else {
				$format = 1;
			}
					
			$result = "";
			//clear old report
			$this->wialon_request("report/cleanup_result","{}");
			
			// $this->wialon_request("report/exec_report",'{"reportResourceId":'.$resource_id.',"reportTemplateId":'.$report_id.',"reportObjectId":'.$unit_id.',"reportObjectSecId":0,"interval":{"from":'.$from.',"to":'.$to.',"flags":0},"reportTemplate":0}');
			
			$this->wialon_request("report/exec_report",'{"reportResourceId":'.$resource_id.',"reportTemplateId":'.$report_id.',"reportObjectId":'.$unit_id.',"reportObjectSecId":0,"interval":{"from":'.$from.',"to":'.$to.',"flags":0},"lang":"' . $lang . '","tzOffset":' . $tzoffset . '}');
			
			
			$data = $this->wialon_request("report/export_result",'{"format":'.$format.',"pageOrientation":"landscap","pageSize":"","pageWidth":"1","coding":"utf8","delimiter":"semicolon","headings":"1","compress":"0","attachMap":"0","hideMapBasis":"1","outputFileName":"'. time() .'"}',1);
				 
			return $data;
		}
		
		
		function get_unit_info($unit_id) {
		
			$result = "";
			$unit = $this->wialon_request("core/search_item",'{"itemId":"' . $unit_id . '","flags":0xF01}');
			if ($unit == "error") 
				return "";
			
			
			//get_list_drivers
			$driver_data = '{"name":"","phone":""}';
			$id_driver = $unit->{'drv'};
						
			$resources = $this->get_items("avl_resource",0x100);
			if(is_array($resources))
			foreach($resources as $resource) {
				$drivers = $resource->{'drvrs'};
				if(is_array($drivers))
				foreach($drivers as $driver) {
					if ($driver->{'c'} == $id_driver) {
						$driver_data = '{"name":"' . $driver->{'nm'} . '","phone":"' . $driver->{'p'} . '"}';
						break;
					}
				}
			}			
			
			$params = "";
			
			if (isset($unit->{'pos'}->{'p'})) {
				foreach($unit->{'pos'}->{'p'} as $name_sens => $sens) {				
								
					if ($params != "")
						$params = $params . ", ";
										
					$sens = str_replace('"', '\'', $sens);
					$sens = str_replace("\r", "", $sens);
					$sens = str_replace("\n", "", $sens);
					$sens = str_replace("\\", "_", $sens);
					$sens = str_replace("/", "_", $sens);

					$params = $params . $name_sens . ": " . $sens;
				}
			}
			
			$sensors_id_name = array();
			if (isset($unit->{'sens'})) {
				foreach($unit->{'sens'} as $id_sens => $sens)
					$sensors_id_name[$id_sens] = $sens->{'nm'};
			}
			
			$sensors = "";
			$sens_arr = $this->wialon_request("unit/calc_last_message",'{"unitId":' . $unit_id . '}');
			if ($sens_arr != "error") {
				foreach($sens_arr as $name_sens => $sens) {
					if ($sensors != "")
						$sensors = $sensors . ", ";
						
					$sensors = $sensors . $sensors_id_name[$name_sens] . ": " . $sens;					
				}
			}
			
			$cmds = "";
			if (isset($unit->{'cml'})) {
				foreach($unit->{'cml'} as $cmd) {				
								
					if ($cmds != "")
						$cmds = $cmds . ", ";
					
					$cmds = $cmds . '"' . $cmd->{'nm'} . '"';
				}
			}
			
			$result = $result . 	'"name":"' . $unit->{'nm'} . '",' . 
						'"phone":"' . $unit->{'ph'} . '",' . 
						'"cmd":[' . $cmds . '],' . 
						'"pos":' . json_encode($unit->{'pos'}) . ',' . 
						'"params":"' . $params . '"' . ',' . 
						'"sensors":"' . $sensors . '"' . ',' . 
						'"driver":' . $driver_data;
			return $result;
		}

		function exec_cmd($unit_id,$cmd,$data) {
			
			$unit = $this->wialon_request("core/search_item",'{"itemId":"' . $unit_id . '","flags":0x200}');
			if ($unit == "error") 
				return "error";
						
			if (isset($unit->{'cml'})) {
				foreach($unit->{'cml'} as $cmd_unit) {						
					$name_cmd = $cmd_unit->{'nm'};
					if ($cmd == $name_cmd) {
						$type_link = $cmd_unit->{'lt'};
						
						$exec = $this->wialon_request("unit/exec_cmd",'{"itemId":' . $unit_id . ',"cmdName":"' . $name_cmd . '","linkType":"' . $type_link . '","cmdParam":"' . $data . '","timeout":20}');
						if ($exec != "error")
							return "ok";
						
						break;
					}
				}
			}
			return "error2";
		}
	} 

?>